another big fix to fedora-mirror for f29
[build.git] / lbuild-nightly.sh
index 20611c8..ace4b47 100755 (executable)
@@ -3,16 +3,20 @@
 COMMANDPATH=$0
 COMMAND=$(basename $0)
 
-# old guests have e.g. mount in /bin but this is no longer part of 
+# close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
+0<&-
+
+# old guests have e.g. mount in /bin but this is no longer part of
 # the standard PATH in recent hosts after usrmove, so let's keep it simple
 export PATH=$PATH:/bin:/sbin
 
 # default values, tunable with command-line options
-DEFAULT_FCDISTRO=f20
-DEFAULT_PLDISTRO=planetlab
+DEFAULT_FCDISTRO=f29
+DEFAULT_PLDISTRO=lxc
 DEFAULT_PERSONALITY=linux64
-DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
+DEFAULT_MAILDEST="build at onelab.eu"
 DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
+DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
 
 # default gpg path used in signing yum repo
 DEFAULT_GPGPATH="/etc/planetlab"
@@ -24,22 +28,11 @@ DEFAULT_TESTCONFIG="default"
 RUN_LOG_EXTRAS=""
 
 # for publishing results, and the tests settings
-x=$(hostname)
-y=$(hostname|sed -e s,inria,,)
-# INRIA defaults
-if [ "$x" != "$y" ] ; then
-    DEFAULT_WEBPATH="/build/@PLDISTRO@/"
-    DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
-    # this is where the buildurl is pointing towards
-    DEFAULT_WEBROOT="/build/"
-    DEFAULT_TESTMASTER="testmaster.onelab.eu"
-else
-    DEFAULT_WEBPATH="/build/@FCDISTRO@/@PLDISTRO@/"
-    DEFAULT_TESTBUILDURL="http://build.planet-lab.org/"
-    # this is where the buildurl is pointing towards
-    DEFAULT_WEBROOT="/build/"
-    DEFAULT_TESTMASTER="manager.test.planet-lab.org"
-fi    
+DEFAULT_WEBPATH="/build/@PLDISTRO@/"
+DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
+# this is where the buildurl is pointing towards
+DEFAULT_WEBROOT="/build/"
+DEFAULT_TESTMASTER="testmaster.onelab.eu"
 
 ####################
 # assuming vm runs in UTC
@@ -59,12 +52,26 @@ function logfile () {
     echo /vservers/$slice.log.txt
 }
 
+########################################
+# workaround for broken lxc-enter-namespace
+# 1st version was relying on virsh net-dhcp-leases
+# however this was too fragile, would not work for fedora14 containers
+# WARNING: this code is duplicated in lbuild-initvm.sh
+function guest_ipv4() {
+    lxc=$1; shift
+
+    mac=$(virsh -c lxc:/// domiflist $lxc | egrep 'network|bridge' | awk '{print $5;}')
+    # sanity check
+    [ -z "$mac" ] && return 0
+    arp -en | grep "$mac" | awk '{print $1;}'
+}
+
 # wrap a quick summary of suspicious stuff
 # this is to focus on installation that go wrong
 # use with care, a *lot* of other things can go bad as well
 function summary () {
     from=$1; shift
-    echo "******************** BEG SUMMARY" 
+    echo "******************** BEG SUMMARY"
     python - $from <<EOF
 #!/usr/bin/env python
 # read a full log and tries to extract the interesting stuff
@@ -108,7 +115,7 @@ def summary (filename):
                 echo=False
             # any 'installing' line
             elif m_installing_any.match(line):
-                if echo: 
+                if echo:
                     installing=m_installing_any.match(line).group(1)
                     print '>>>',installing
                 echo=False
@@ -122,7 +129,7 @@ def summary (filename):
 for arg in sys.argv[1:]:
     summary(arg)
 EOF
-    echo "******************** END SUMMARY" 
+    echo "******************** END SUMMARY"
 }
 
 ### we might build on a box other than the actual web server
@@ -139,12 +146,23 @@ function webpublish_rsync_files () {
     rsync --archive $VERBOSE "$@" root@${WEBHOST}:"$remote" ;
 }
 
-# Notify recipient of failure or success, manage various stamps 
+function pretty_duration () {
+    total_seconds=$1; shift
+
+    seconds=$(($total_seconds%60))
+    total_minutes=$(($total_seconds/60))
+    minutes=$(($total_minutes%60))
+    hours=$(($total_minutes/60))
+
+    printf "%02d:%02d:%02d" $hours $minutes $seconds
+}
+
+# Notify recipient of failure or success, manage various stamps
 function failure() {
     set -x
     # early stage ? - let's not create /build/@PLDISTRO@
-    if test -z "$WEBLOG" ; then
-       WEBHOST=$(hostname)
+    if  [ -z "$WEBLOG" ] ; then
+       WEBHOST=localhost
        WEBPATH=/tmp
        WEBBASE=/tmp/lbuild-early-$(date +%Y-%m-%d)
        WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
@@ -155,16 +173,16 @@ function failure() {
     (echo -n "============================== $COMMAND: failure at " ; date ; \
        webpublish tail --lines=1000 $WEBLOG) | \
        webpublish_cp_stdin_to_file $WEBBASE.ko ||:
-    if [ -n "$MAILTO" ] ; then
+    if [ -n "$MAILDEST" ] ; then
        ( \
            echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
-           echo "To: $MAILTO" ; \
+           echo "To: $MAILDEST" ; \
            echo "see build results at        $WEBBASE_URL" ; \
            echo "including full build log at $WEBBASE_URL/log.txt" ; \
            echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
            echo "........................................" ; \
            webpublish tail --lines=1000 $WEBLOG ) | \
-           sendmail $MAILTO
+           sendmail $MAILDEST
     fi
     exit 1
 }
@@ -172,8 +190,8 @@ function failure() {
 function success () {
     set -x
     # early stage ? - let's not create /build/@PLDISTRO@
-    if test -z "$WEBLOG" ; then
-       WEBHOST=$(hostname)
+    if [ -z "$WEBLOG" ] ; then
+       WEBHOST=localhost
        WEBPATH=/tmp
        WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
     fi
@@ -203,17 +221,17 @@ function success () {
     fi
     BUILD_END=$(date +'%H:%M')
     BUILD_END_S=$(date +'%s')
-    if [ -n "$MAILTO" ] ; then
+    if [ -n "$MAILDEST" ] ; then
        ( \
            echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
-           echo "To: $MAILTO" ; \
+           echo "To: $MAILDEST" ; \
            echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
            echo "see build results at        $WEBBASE_URL" ; \
            echo "including full build log at $WEBBASE_URL/log.txt" ; \
             [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
            [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
-           echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(($BUILD_END_S-$BUILD_BEG_S))" ; \
-           ) | sendmail $MAILTO
+           echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(pretty_duration $(($BUILD_END_S-$BUILD_BEG_S)))" ; \
+           ) | sendmail $MAILDEST
     fi
     # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
     # doesn't fix the problem, I'll remove it -- Sapan.
@@ -224,7 +242,13 @@ function success () {
 ##############################
 # manage root / container contexts
 function in_root_context () {
-    rpm -q libvirt > /dev/null 
+    rpm -q libvirt > /dev/null
+}
+
+# convenient for simple commands
+function run_in_build_guest () {
+    buildname=$1; shift
+    ssh -o "StrictHostKeyChecking no" root@$(guest_ipv4 $buildname) "$@"
 }
 
 # run in the vm - do not manage success/failure, will be done from the root ctx
@@ -237,15 +261,15 @@ function build () {
 
     cd /build
     show_env
-    
+
     echo "Running make IN $(pwd)"
-    
+
     # stuff our own variable settings
     MAKEVARS=("build-GITPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
     MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
     MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
     MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
-    MAKEVARS=("MAILTO=${MAILTO}" "${MAKEVARS[@]}")
+    MAKEVARS=("MAILDEST=${MAILDEST}" "${MAKEVARS[@]}")
     MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
     MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
     MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
@@ -256,7 +280,7 @@ function build () {
     /build/latex-first-run.sh || :
 
     # stage1
-    make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true 
+    make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true
     # versions
     make -C /build $DRY_RUN "${MAKEVARS[@]}" versions
     # actual stuff
@@ -301,26 +325,29 @@ function run_log () {
     ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
 
     # check it out in the build
-    virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "make -C /build tests-module"
-    
+    run_in_build_guest $BASE make -C /build tests-module ${MAKEVARS[@]}
+
     # push it onto the testmaster - just the 'system' subdir is enough
     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
     # toss the build in the bargain, so the tests don't need to mess with extracting it
     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/build ${testmaster_ssh}:${BASE}/
 
-    # invoke test on testbox - pass url and build url - so the tests can use vtest-init-lxc.sh
+    # invoke test on testbox - pass url and build url - so the tests can use lbuild-initvm.sh
     run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
 
     # temporarily turn off set -e
     set +e
-    ssh 2>&1 -n ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
+    trap - ERR INT
+    ssh 2>&1 ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
+
     set -e
-    
+    trap failure ERR INT
     # interpret retcod of TestMain.py; 2 means there were ignored steps that failed
+    echo "retcod from run_log" $retcod
     case $retcod in
        0) success=true; IGNORED="" ;;
-       1) success=true; IGNORED=true ;;
-       *) success="" ;; 
+       2) success=true; IGNORED=true ;;
+       *) success="";   IGNORED="" ;;
     esac
 
     # gather logs in the build vm
@@ -336,7 +363,7 @@ function run_log () {
        echo "Tests have failed - bailing out"
        failure
     fi
-    
+
 }
 
 # this part won't work if WEBHOST does not match the local host
@@ -345,7 +372,7 @@ function run_log () {
 function sign_node_packages () {
 
     echo "Signing node packages"
-    
+
     need_createrepo=""
 
     repository=$WEBPATH/$BASE/RPMS/
@@ -368,7 +395,7 @@ function sign_node_packages () {
     if [ -n "$new_rpms" ] ; then
         # Create a stamp once the package gets signed
         mkdir $repository/signed-stamps 2> /dev/null
-       
+
         # Sign RPMS. setsid detaches rpm from the terminal,
         # allowing the (hopefully blank) GPG password to be
         # entered from stdin instead of /dev/tty.
@@ -379,7 +406,7 @@ function sign_node_packages () {
             --resign $new_rpms && touch $new_stamps
     fi
 
-     # Update repository index / yum metadata. 
+     # Update repository index / yum metadata.
     if [ -n "$need_createrepo" ] ; then
        echo "Indexing node packages after signing"
         if [ -f $repository/yumgroups.xml ] ; then
@@ -421,7 +448,7 @@ function show_env () {
 function setupssh () {
     base=$1; shift
     sshkey=$1; shift
-    
+
     if [ -f ${sshkey} ] ; then
        SSHDIR=$(rootdir ${base})/root/.ssh
        mkdir -p ${SSHDIR}
@@ -431,7 +458,7 @@ function setupssh () {
            echo "  StrictHostKeyChecking no" ) > ${SSHDIR}/config
        chmod 700 ${SSHDIR}
        chmod 400 ${SSHDIR}/*
-    else 
+    else
        echo "WARNING : could not find provided ssh key $sshkey - ignored"
     fi
 }
@@ -442,7 +469,7 @@ function usage () {
     echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
-    echo " -m mailto - no default"
+    echo " -m mailto - defaults to $DEFAULT_MAILDEST"
     echo " -s build_scm_url - git URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
     echo "    define GIT tag or branch name appending @tagname to url"
     echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
@@ -462,7 +489,7 @@ function usage () {
     echo " -r webroot - defaults to $DEFAULT_WEBROOT - the fs point where testbuildurl actually sits"
     echo " -M testmaster - defaults to $DEFAULT_TESTMASTER"
     echo " -Y - sign yum repo in webpath"
-    echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH" 
+    echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH"
     echo " -u gpg_uid - email used in secring. Defaults to $DEFAULT_GPGUID"
     echo " -K sshkey - specify ssh key to use when reaching git over ssh"
     echo " -S - do not publish source rpms"
@@ -478,6 +505,7 @@ function usage () {
 function main () {
 
     set -e
+    trap failure ERR INT
 
     # parse arguments
     MAKEVARS=()
@@ -501,7 +529,7 @@ function main () {
            -f) FCDISTRO=$2; shift 2 ;;
            -d) PLDISTRO=$2; shift 2 ;;
            -p) PERSONALITY=$2; shift 2 ;;
-           -m) MAILTO=$2; shift 2 ;;
+           -m) MAILDEST=$2; shift 2 ;;
            -s) BUILD_SCM_URL=$2; shift 2 ;;
            -t) PLDISTROTAGS=$2; shift 2 ;;
            -b) BASE=$2; shift 2 ;;
@@ -544,7 +572,7 @@ function main () {
     # preserve options for passing them again later, together with expanded base
     options=$OPTS_ORIG
 
-    # allow var=value stuff; 
+    # allow var=value stuff;
     for target in "$@" ; do
        # check if contains '='
        target1=$(echo $target | sed -e s,=,,)
@@ -554,11 +582,12 @@ function main () {
            MAKEVARS=(${MAKEVARS[@]} "$target")
        fi
     done
-    
+
     # set defaults
     [ -z "$FCDISTRO" ] && FCDISTRO=$DEFAULT_FCDISTRO
     [ -z "$PLDISTRO" ] && PLDISTRO=$DEFAULT_PLDISTRO
     [ -z "$PERSONALITY" ] && PERSONALITY=$DEFAULT_PERSONALITY
+    [ -z "$MAILDEST" ] && MAILDEST=$(echo $DEFAULT_MAILDEST | sed -e 's, at ,@,')
     [ -z "$PLDISTROTAGS" ] && PLDISTROTAGS="${PLDISTRO}-tags.mk"
     [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
     [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
@@ -570,14 +599,14 @@ function main () {
     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
     [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
 
-    [ -n "$DRY_RUN" ] && MAILTO=""
+    [ -n "$DRY_RUN" ] && MAILDEST=""
 
     # elaborate the extra args to be passed to run_log
     for config in ${TESTCONFIG} ; do
        RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --config $config"
     done
-    
-       
+
+
     if [ -n "$OVERBASE" ] ; then
        sedargs="-e s,@DATE@,${DATE},g"
        BASE=$(echo ${OVERBASE} | sed $sedargs)
@@ -602,7 +631,7 @@ function main () {
     short_hostname=$(hostname | cut -d. -f1)
     MAIL_SUBJECT="on ${short_hostname} - ${MAIL_SUBJECT}"
 
-    ### compute WEBHOST from TESTBUILDURL 
+    ### compute WEBHOST from TESTBUILDURL
     # this is to avoid having to change the builds configs everywhere
     # simplistic way to extract hostname from a URL
     WEBHOST=$(echo "$TESTBUILDURL" | cut -d/ -f 3)
@@ -615,11 +644,11 @@ function main () {
 
     else
        trap failure ERR INT
-        # we run in the root context : 
+        # we run in the root context :
         # (*) create or check for the vm to use
         # (*) copy this command in the vm
         # (*) invoke it
-       
+
        if [ -n "$OVERBASE" ] ; then
             ### Re-use a vm (finish an unfinished build..)
            if [ ! -d $(rootdir ${BASE}) ] ; then
@@ -635,22 +664,22 @@ function main () {
            # start in case e.g. we just rebooted
            virsh -c lxc:/// start ${BASE} || :
            # retrieve environment from the previous run
-           FCDISTRO=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/getdistroname.sh)
-           BUILD_SCM_URL=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip +build-GITPATH")
+           FCDISTRO=$(run_in_build_guest $BASE /build/getdistroname.sh)
+           BUILD_SCM_URL=$(run_in_build_guest $BASE make --no-print-directory -C /build stage1=skip +build-GITPATH)
            # for efficiency, crop everything in one make run
            tmp=/tmp/${BASE}-env.sh
-           virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip \
-               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT" > $tmp
+           run_in_build_guest $BASE make --no-print-directory -C /build stage1=skip \
+               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILDEST ++WEBPATH ++TESTBUILDURL ++WEBROOT > $tmp
            . $tmp
            rm -f $tmp
            # update build
            [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "cd /build; git pull; make tests-clean"
+           run_in_build_guest $BASE "(cd /build; git pull; make tests-clean)"
            # make sure we refresh the tests place in case it has changed
            rm -f /build/MODULES/tests
            options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
            [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
-           [ -n "$MAILTO" ] && options=(${options[@]} -m $MAILTO)
+           [ -n "$MAILDEST" ] && options=(${options[@]} -m $MAILDEST)
            [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
            [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
            [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
@@ -672,7 +701,7 @@ function main () {
            # manage LOG - beware it might be a symlink so nuke it first
            LOG=$(logfile ${BASE})
            rm -f $LOG
-           exec > $LOG 2>&1 
+           exec > $LOG 2>&1
            set -x
            echo "XXXXXXXXXX $COMMAND: creating vm $BASE" $(date)
            show_env
@@ -682,18 +711,20 @@ function main () {
            GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
            GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
            GIT_TAG=${GIT_TAG:-master}
-           mkdir -p $tmpdir; git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -
+           mkdir -p $tmpdir
+            ( git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -) || \
+               ( echo "==================== git archive FAILED, trying git clone instead" ; \
+                 git clone $GIT_REPO $tmpdir && cd $tmpdir && git checkout $GIT_TAG && rm -rf .git)
 
             # Create lxc vm
            cd $tmpdir
-           ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} ${PREINSTALLED} ${BASE} 
+           ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} ${PREINSTALLED} ${BASE}
            # cleanup
            cd -
            rm -rf $tmpdir
            # Extract build again - in the vm
            [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           # xxx not working as of now - waiting for Sapan to look into this
-           virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
+           run_in_build_guest $BASE "(git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG)"
        fi
        echo "XXXXXXXXXX $COMMAND: preparation of vm $BASE done" $(date)
 
@@ -707,7 +738,7 @@ function main () {
        rm $LOG; ln -s $LOG2 $LOG
        LOG=$LOG2
        # redirect log again
-       exec >> $LOG 2>&1 
+       exec >> $LOG 2>&1
 
        sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
        WEBPATH=$(echo ${WEBPATH} | sed $sedargs)
@@ -718,20 +749,21 @@ function main () {
        WEBLOG=${WEBPATH}/${BASE}/log.txt
         # compute the log URL - inserted in the mail messages for convenience
        WEBBASE_URL=$(echo $WEBBASE | sed -e "s,//,/,g" -e "s,${WEBROOT},${TESTBUILDURL},")
-    
-       if [ -n "$DO_BUILD" ] ; then 
+
+       if [ -n "$DO_BUILD" ] ; then
 
            # invoke this command into the build directory of the vm
            cp $COMMANDPATH $(rootdir ${BASE})/build/
 
            # invoke this command in the vm for building (-T)
-           virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "chmod +x /build/$COMMAND"
-           virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
+           run_in_build_guest $BASE chmod +x /build/$COMMAND
+           run_in_build_guest $BASE /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
        fi
 
        # publish to the web so run_log can find them
        set +e
-       webpublish rm -rf $WEBPATH/$BASE 
+       trap - ERR INT
+       webpublish rm -rf $WEBPATH/$BASE
        # guess if we've been doing any debian-related build
        if [ ! -f $(rootdir $BASE)/etc/debian_version  ] ; then
            webpublish mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
@@ -740,15 +772,16 @@ function main () {
        else
            # run scanpackages so we can use apt-get on this
            # (not needed on fedora b/c this is done by the regular build already)
-           virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
+           run_in_build_guest $BASE "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
            webpublish mkdir -p $WEBPATH/$BASE/DEBIAN
-           webpublish_rsync_files $WEBPATH/$BASE/DEBIAN/ $(rootdir $BASE)/build/DEBIAN/*.deb 
+           webpublish_rsync_files $WEBPATH/$BASE/DEBIAN/ $(rootdir $BASE)/build/DEBIAN/*.deb
            webpublish_rsync_files $WEBPATH/$BASE/ $(rootdir $BASE)/build/Packages.gz
        fi
        # publish myplc-release if this exists
        release=$(rootdir $BASE)/build/myplc-release
        [ -f $release ] && webpublish_rsync_files $WEBPATH/$BASE $release
        set -e
+       trap failure ERR INT
 
         # create yum repo and sign packages.
        if [ -n "$SIGNYUMREPO" ] ; then
@@ -763,16 +796,16 @@ function main () {
            fi
        fi
 
-       if [ -n "$DO_TEST" ] ; then 
+       if [ -n "$DO_TEST" ] ; then
            run_log
        fi
 
-       success 
+       success
 
-        echo "==================== MAIN END $(date)"   
+        echo "==================== MAIN END $(date)"
     fi
 
 }
 
 ##########
-main "$@" 
+main "$@"